/* ShowBMP -	A small application demonstarting the usage of CreateBmpFromMem
				The application loads and displays a bmp
				Version 1.00 by Vortex */

#define WIN32_LEAN_AND_MEAN 
#include <windows.h>

#include "Rsrc.h"

extern HBITMAP __stdcall  CreateBmpFromMem( HWND hWnd , void* pBitmap , void* HDCtemp) ;	/* Declare the external function from GeneSys.lib */

BOOL CALLBACK DlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;
	HDC hMemDC;
	HANDLE hFile;
	DWORD pBytesRead;
	DWORD nFileSize;
	static HBITMAP hBitmap;
	static HANDLE hHeap;
	static LPVOID *pBitmap;
	static HDC hDCtemp;

   switch(msg)
    {
    	  	case WM_INITDIALOG:
			hHeap=GetProcessHeap();
			hFile=CreateFile("Fish.bmp",GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0);

			if (hFile==INVALID_HANDLE_VALUE) {											/* Display an error message if the the bmp cannot be opened */

    	 											MessageBox(0,"Could not open file Fish.bmp","Error",MB_OK);
    	 											EndDialog(hWnd,0);
    	 											return FALSE; 								/* Terminate application */
				}
			nFileSize=GetFileSize(hFile,0);
			pBitmap=HeapAlloc(hHeap,HEAP_GENERATE_EXCEPTIONS,nFileSize);			/* Allocate memory before loading the bmp */
			ReadFile(hFile,pBitmap,nFileSize,&pBytesRead,0);
			CloseHandle(hFile);
			hBitmap=CreateBmpFromMem(hWnd,pBitmap,&hDCtemp);							/* Get the handle of the loaded bmp */
    	 	break;

		case WM_PAINT:
			hdc=BeginPaint(hWnd,&ps);
			hMemDC=CreateCompatibleDC(hdc);
			SelectObject(hMemDC,hBitmap);
			BitBlt(hdc,40,15,102,100,hMemDC,0,0,SRCCOPY);								/* Display the bmp */
			DeleteDC(hMemDC);
			EndPaint(hWnd,&ps);
		break;

		case WM_CLOSE:
			DeleteObject(hBitmap);
			ReleaseDC(hWnd,hDCtemp);														/* Release temporary DC to get handle of the bmp */
			HeapFree(hHeap,0,pBitmap);														/* Release memory allocated for the bmp */
  	  	 	EndDialog(hWnd,0);
            break;

 	 	default:
			return FALSE;
    }
     return TRUE;

}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow)
{
	return (DialogBoxParam(hInstance,MAKEINTRESOURCE (MyDialog),0,DlgProc,0));			/* Display the dialog box */
}



